#include "cgic.h"
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include "bible2.h"
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

void replacing(char []); 

int ft = 0;

int cgiMain() {
char oneline[3000], filename[100], line2[3000], *lptr, name[20], ver1[5], *p1, name_old[20];
int fd1, size, i, j, num, chap_num, k, v1 = 0, ch_old, len_old;
FILE *infptr1, *infptr2;
struct chapternode1 chapter0, chapter[160];
int ch, verse, len, now, end1, endv, endc, ss;

#if DEBUG
        /* Load a saved CGI scenario if we're debugging */
        cgiReadEnvironment("/home/boutell/public_html/capcgi.dat");
#endif


	for(i = 0;i < FLNUM;i++)
	  if(strstr(cgiReferrer, fortune_tellingurl[i]))
	    break;

	if(i < FLNUM) {
	  cgiHeaderLocation("search101.cgi?s=3&st1=eR|kN|N|L|[|氭|ųN"); 
	  return 0;
	}

        cgiHeaderContentType("text/html");

	cgiFormString("na", name, 10);
	cgiFormString("ver", ver1, 5);
	cgiFormString("nao", name_old, 10);
	cgiFormIntegerBounded("ch", &ch, 1, 1189, 1);
	cgiFormIntegerBounded("cho", &ch_old, 1, 1189, 1);
	cgiFormIntegerBounded("leno", &len_old, 1, 5, 1);
	cgiFormIntegerBounded("v", &verse, 1, 169, 1);
	cgiFormIntegerBounded("len", &len, 1, 3000, 1);
	cgiFormIntegerBounded("ft",&ft,0, FTNUM,0);
	cgiFormIntegerBounded("s",&ss,0, 1, 0);

	for(i = 0;i < VERNUM;i++)
		if(strcmp(ver1, version1[i].name) == 0)
			break;
	if(i < VERNUM) v1 = i;

	num = 0;
	for(i = 0;i < 66;i++)
	  if((strcmp(name, bible_book[i].name) == 0)||(strcmp(name, bible_book[i].en_name) == 0))
	    break;
	if(i <= 65) num = i;

/*  strcpy(filename, version1[v1].indexfilename);*/
  sprintf(filename, "%s%s", DATA, version1[v1].indexfilename);

  if ((fd1 = open(filename, O_RDONLY)) == -1)
    exit(-1);

  size = sizeof(struct chapternode1);

  if(num > 0) {
    lseek(fd1, bible_book[num-1].chap_num * size, SEEK_SET);
    read(fd1, &chapter0, size);
  }
  
  chap_num = bible_book[num+1].chap_num - bible_book[num].chap_num; 
  lseek(fd1, bible_book[num].chap_num * size, SEEK_SET);
  for(i = 0;i <= chap_num;i++) 
    read(fd1, &chapter[i], size);
  close(fd1);

  end1 = chapter[ch-1].linenum + verse - 1 + len;
  for(i = ch;i <= chap_num;i++) 
    if(end1 <= chapter[i].linenum)
      break;
  endv = end1 - chapter[i-1].linenum;
  endc = i-1;

             

/*  strcpy(filename, version1[v1].textfilename);*/
  sprintf(filename, "%s%s", DATA, version1[v1].textfilename);
  infptr1 = fopen(filename, "r");
  sprintf(filename, "%s%s", FORMAT, format[ft]);
  infptr2 = fopen(filename, "r");

  while(fgets(oneline, 1000, infptr2) != NULL)
    if(strstr(oneline, "[body]") == NULL) {
      if(strstr(oneline, "[title]") == NULL)
	fprintf(cgiOut, "%s", oneline);
      else 
	if(version1[v1].language == 'c') {
	  fprintf(cgiOut, "%s%s%d`%s%d`</title>\n", chapter[ch-1].full_name, chapter[ch-1].number, verse, chapter[endc].number, endv); 
          fprintf(cgiOut, "<meta http-equiv=\"Content-Type\" CONTENT=\"text/html; charset=big5\">\n"); 
	} else if (version1[v1].language == 'g') {
	  fprintf(cgiOut, "%s</title>\n", bible_book[num].gb_fullname); 
          fprintf(cgiOut, "<meta HTTP-EQUIV=Content-Type CONTENT=\"text/html; charset=GB2312\">\n");
        } else 
	  fprintf(cgiOut, "%s</title>\n", bible_book[num].en_fullname); 

    } else {
	if(!ss) {
	fprintf(cgiOut, "<center>\n");
	for(i = 0;i < VERNUM;i++)
	  if(i != v1) {
	    if(version1[v1].language != 'g')
	      fprintf(cgiOut,"<a href=\"%sread001.cgi?ver=%s&na=%s&ft=%d&ch=%d&v=%d&len=%d&s=%d\">%s</a> \n", HOME2, version1[i].name, bible_book[num].en_name, ft, ch, verse, len, ss, version1[i].fullname);
	    else
	      fprintf(cgiOut,"<a href=\"%sread001.cgi?ver=%s&na=%s&ft=%d&ch=%d&v=%d&len=%d&s=%d\">%s</a> \n", HOME2, version1[i].name, bible_book[num].en_name, ft, ch, verse, len, ss, version1[i].gb_fullname);
	  }
	fprintf(cgiOut, "</center>\n");
	}

	if (version1[v1].language == 'c') 
	  fprintf(cgiOut, "<p /><center><font size=\"6\">%s%s%d`%s%d`</font>\n", chapter[ch-1].full_name, chapter[ch-1].number, verse, chapter[endc].number, endv); 
//          fprintf(cgiOut, "<center><font size=6>%s</font>\n", bible_book[num].full_name); 
	else if (version1[v1].language == 'g') 
          fprintf(cgiOut, "<center><font size=6>%s</font>\n", bible_book[num].gb_fullname); 
	else
          fprintf(cgiOut, "<center><font size=6>%s</font>\n", bible_book[num].en_fullname); 
      fprintf(cgiOut, "</center><br>\n");
      if(!ss) {
      fprintf(cgiOut, "<center>");
      for(k = bible_book[num].chap_num;k < bible_book[num+1].chap_num;k++)
	fprintf(cgiOut, "<a href=\"%sread201.cgi?na=%s&ft=%d&chap=%d\">%c%d</a>\n", HOME2, bible_book[num].en_name, ft, k+1-bible_book[num].chap_num, ((k-bible_book[num].chap_num) < 9)?'0':' ', k+1-bible_book[num].chap_num);
      fprintf(cgiOut, "</center><br>\n");

      if(num > 0) 
        fprintf(cgiOut, "<a href=\"%sread201.cgi?na=%s&ver=%s&ft=%d&chap=01\">%s %s</a> ", HOME2, bible_book[num-1].en_name, version1[v1].name, ft, chapter0.full_name, chapter0.number);
      if(num < 65) 
        fprintf(cgiOut, "<a href=\"%sread201.cgi?na=%s&ver=%s&ft=%d&chap=01\">%s %s</a>", HOME2, bible_book[num+1].en_name, version1[v1].name, ft, chapter[chap_num].full_name, chapter[chap_num].number);
      }
      fprintf(cgiOut, "<hr><font size=4>\n");
      fprintf(cgiOut, "<font color=\"#FF0000\" size=5>%s %s</font>\n", chapter[ch-1].full_name, chapter[ch-1].number);
      fprintf(cgiOut,"<ol start=%d>\n", verse);

      ch = (ch <= 0) ? 1 : ch;
      verse = (verse <= 0) ? 1 : verse;
      j = ch;
      now = chapter[ch-1].linenum + verse - 1;
      fseek(infptr1, chapter[ch-1].index, SEEK_SET); 
      for(i = 0;i < verse - 1;i++)	//NޥΪgŪ
	fgets(line2, 1000, infptr1);


      for(i = 0;i < len;i++) {
	if(now >= chapter[j].linenum) {
	  fprintf(cgiOut, "</ol><p><font color=\"#FF0000\" size=5>%s%s</font><ol>\n", chapter[j].full_name, chapter[j].number);
	  j++;
	}
	if(fgets(line2, 1000, infptr1) == NULL)
	  break;
	now++;
	lptr = strstr(line2, " ");
        if((strstr(line2, "<W") != NULL) && (version1[v1].language == 'c')) {
          if((p1 = strchr(line2, '#')) != NULL) {
//        p1 = index(line2, '#');
            *p1 = '\0';
            replacing(lptr+1);
          }
        }
	fprintf(cgiOut, "<li>%s<p>\n", lptr+1);
      }
      fprintf(cgiOut, "</ol></font><hr>\n");
      if(!ss) {
      if(num > 0) 
        fprintf(cgiOut, "<a href=\"%sread201.cgi?na=%s&ver=%s&ft=%d&chap=01\">%s %s</a> ", HOME2, bible_book[num-1].en_name, version1[v1].name, ft, chapter0.full_name, chapter0.number);
      if(num < 65) 
        fprintf(cgiOut, "<a href=\"%sread201.cgi?na=%s&ver=%s&ft=%d&chap=01\">%s %s</a>@", HOME2, bible_book[num+1].en_name, version1[v1].name, ft, chapter[chap_num].full_name, chapter[chap_num].number);

	fprintf(cgiOut, "<center>\n");
	for(i = 0;i < VERNUM;i++)
	  if(i != v1) {
	    if(version1[v1].language != 'g')
	      fprintf(cgiOut,"<a href=\"%sread001.cgi?ver=%s&na=%s&ft=%d&ch=%d&v=%d&len=%d&s=%d\">%s</a> \n", HOME2, version1[i].name, bible_book[num].en_name, ft, ch, verse, len, ss, version1[i].fullname);
	    else
	      fprintf(cgiOut,"<a href=\"%sread001.cgi?ver=%s&na=%s&ft=%d&ch=%d&v=%d&len=%d&s=%d\">%s</a> \n", HOME2, version1[i].name, bible_book[num].en_name, ft, ch, verse, len, ss, version1[i].gb_fullname);
	  }
	fprintf(cgiOut, "</center>\n");
      }
    }
  
  fclose(infptr1);
  fclose(infptr2);


  return 0;
}

void replacing(char oneline[]) {
  char s1[10], s2[10], *cptr, *c1ptr, *c2ptr, templine[10000], temp1[1000], *tptr;

  strcpy(templine, oneline);
  oneline[0] = '\0';

  cptr = templine;
  while((c1ptr = strstr(cptr, "<W")) != NULL) {
    c2ptr = strchr(c1ptr, '>');
    strncpy(s1, c1ptr, c2ptr-c1ptr);
    s1[c2ptr-c1ptr] = '\0';
    for(tptr = s1;*tptr != '\0';tptr++)
      if(isdigit(*tptr)) break;
    strcpy(s2, tptr);
    *c1ptr= '\0';
    strcat(oneline, cptr);
    sprintf(temp1, "<a href=\"%sdic.cgi?N=%d&k=%s&ft=%d\">&lt;%s&gt;</a>", HOME2, (strchr(s1, 'G')) ? 0 : 1, s2, ft, s2);
    strcat(oneline, temp1);
    cptr = c2ptr + 1;
  }
  strcat(oneline, cptr);
}
