#include "cgic.h"
#include <string.h>
#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include "bible2.h"
#include <stdlib.h>
#include <unistd.h>

int cgiMain() {
char oneline[1000], filename[100], line2[1000], *lptr, name[20];
int fd1, size, i, j, num, chap_num, k;
FILE *infptr1, *infptr2;
struct chapternode1 chapter0, chapter[160];

#if DEBUG
        /* Load a saved CGI scenario if we're debugging */
        cgiReadEnvironment("/home/boutell/public_html/capcgi.dat");
#endif

        cgiHeaderContentType("text/html");

	cgiFormString("na", name, 10);
	num = 0;
	for(i = 0;i < 66;i++)
	  if(strcmp(name, bible_book[i].name) == 0)
	    break;
	if(i <= 65) num = i;

  strcpy(filename, "Data/bible.cidx");

  if ((fd1 = open(filename, O_RDONLY)) == -1)
    exit(-1);

  size = sizeof(struct chapternode1);

  if(num > 0) {
    lseek(fd1, bible_book[num-1].chap_num * size, SEEK_SET);
    read(fd1, &chapter0, size);
  }
  
  chap_num = bible_book[num+1].chap_num - bible_book[num].chap_num; 
  lseek(fd1, bible_book[num].chap_num * size, SEEK_SET);
  for(i = 0;i <= chap_num;i++) 
    read(fd1, &chapter[i], size);

  close(fd1);
             

  strcpy(filename, "Data/bible.txt");
  infptr1 = fopen(filename, "r");
  infptr2 = fopen("Format/format1.html", "r");

  while(fgets(oneline, 1000, infptr2) != NULL)  {
    if(strstr(oneline, "[body]") == NULL)
      if(strstr(oneline, "[title]") == NULL)
	fprintf(cgiOut, "%s", oneline);
      else 
	fprintf(cgiOut, "%s</title>\n", bible_book[num].full_name); 
    else {
      fprintf(cgiOut, "<center><font size=6>%s</font><br>\n", bible_book[num].full_name); 
      for(k = bible_book[num].chap_num;k < bible_book[num+1].chap_num;k++)
	fprintf(cgiOut, "<a href=\"#ch%d\">%c%d</a>\n", k+1-bible_book[num].chap_num, ((k-bible_book[num].chap_num) < 9)?'0':' ', k+1-bible_book[num].chap_num);
      fprintf(cgiOut, "</center><br>\n");

      fprintf(cgiOut, "@ %ld `g@", chapter[chap_num].linenum - chapter[0].linenum);
      if(num > 0) 
        fprintf(cgiOut, "<a href=\"read100.cgi?na=%s\">%s%s</a>@", bible_book[num-1].name, chapter0.full_name, chapter0.number);
      if(num < 65) 
        fprintf(cgiOut, "<a href=\"read100.cgi?na=%s\">%s%s</a>", bible_book[num+1].name, chapter[chap_num].full_name, chapter[chap_num].number);
      fprintf(cgiOut, "<hr><font size=4>\n");

      fseek(infptr1, chapter[0].index, SEEK_SET); 
      for(i = 0;i < chap_num;i++) {
	fprintf(cgiOut, "<a name=\"ch%d\"><a href=\"#ch%d\"><font size=5 color=\"ff0000\">%s%s</font></a> @ %ld `g<p>\n<ol>\n", i+1, i+1, chapter[i].full_name, chapter[i].number, chapter[i+1].linenum-chapter[i].linenum);
	for(j = chapter[i].linenum;j < chapter[i+1].linenum;j++) {
	  fgets(line2, 1000, infptr1);
	  lptr = strstr(line2, " ");
	  fprintf(cgiOut, "<li>%s<p>\n", lptr+1);
	}
	fprintf(cgiOut, "</ol><p>\n");
      }

      fprintf(cgiOut, "</font><hr>\n");
      if(num > 0) 
        fprintf(cgiOut, "<a href=\"read100.cgi?na=%s\">%s%s</a>@", bible_book[num-1].name, chapter0.full_name, chapter0.number);
      if(num < 65) 
        fprintf(cgiOut, "<a href=\"read100.cgi?na=%s\">%s%s</a>@", bible_book[num+1].name, chapter[chap_num].full_name, chapter[chap_num].number);

    }
  
  }
  fclose(infptr1);
  fclose(infptr2);


  return 0;
}

